diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/eht/emlsr-manager.h ns-3.40/src/wifi/model/eht/emlsr-manager.h
--- ns-3.39/src/wifi/model/eht/emlsr-manager.h	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/eht/emlsr-manager.h	2023-09-27 13:30:37.902840000 -0700
@@ -20,11 +20,14 @@
 #ifndef EMLSR_MANAGER_H
 #define EMLSR_MANAGER_H
 
+#include "ns3/ctrl-headers.h"
 #include "ns3/mac48-address.h"
 #include "ns3/mgt-headers.h"
 #include "ns3/object.h"
 #include "ns3/sta-wifi-mac.h"
+#include "ns3/wifi-phy-operating-channel.h"
 
+#include <map>
 #include <optional>
 #include <set>
 
@@ -71,6 +74,19 @@
     std::optional<Time> GetTransitionTimeout() const;
 
     /**
+     * Set the ID of main PHY (position in the vector of PHYs held by WifiNetDevice). This
+     * method cannot be called during or after initialization.
+     *
+     * \param mainPhyId the ID of the main PHY
+     */
+    void SetMainPhyId(uint8_t mainPhyId);
+
+    /**
+     * \return the ID of main PHY (position in the vector of PHYs held by WifiNetDevice)
+     */
+    uint8_t GetMainPhyId() const;
+
+    /**
      * Take actions to enable EMLSR mode on the given set of links, if non-empty, or
      * disable EMLSR mode, otherwise.
      *
@@ -85,6 +101,20 @@
     const std::set<uint8_t>& GetEmlsrLinks() const;
 
     /**
+     * Set the member variable indicating whether the state of the CAM should be reset when
+     * the main PHY switches channel and operates on the link associated with the CAM.
+     *
+     * \param enable whether the CAM state should be reset
+     */
+    void SetCamStateReset(bool enable);
+
+    /**
+     * \return the value of the member variable indicating whether the state of the CAM should be
+     * reset when the main PHY switches channel and operates on the link associated with the CAM.
+     */
+    bool GetCamStateReset() const;
+
+    /**
      * Notify the reception of a management frame addressed to us.
      *
      * \param mpdu the received MPDU
@@ -92,6 +122,27 @@
      */
     void NotifyMgtFrameReceived(Ptr<const WifiMpdu> mpdu, uint8_t linkId);
 
+    /**
+     * Notify the reception of an initial Control frame on the given link.
+     *
+     * \param linkId the ID of the link on which the initial Control frame was received
+     */
+    void NotifyIcfReceived(uint8_t linkId);
+
+    /**
+     * Notify the start of an UL TXOP on the given link
+     *
+     * \param linkId the ID of the given link
+     */
+    void NotifyUlTxopStart(uint8_t linkId);
+
+    /**
+     * Notify the end of a TXOP on the given link.
+     *
+     * \param linkId the ID of the given link
+     */
+    void NotifyTxopEnd(uint8_t linkId);
+
   protected:
     void DoDispose() override;
 
@@ -109,7 +160,7 @@
     /**
      * \return the ID of the link on which the EML Operating Mode Notification frame has to be sent
      */
-    virtual uint8_t GetLinkToSendEmlNotification() = 0;
+    virtual uint8_t GetLinkToSendEmlOmn() = 0;
 
     /**
      * A previous EML Operating Mode Notification frame was dropped. Ask the subclass whether
@@ -120,14 +171,43 @@
      */
     virtual std::optional<uint8_t> ResendNotification(Ptr<const WifiMpdu> mpdu) = 0;
 
+    /**
+     * \param linkId the ID of the given link
+     * \return the operating channel the main PHY must switch to in order to operate
+     *         on the given link
+     */
+    const WifiPhyOperatingChannel& GetChannelForMainPhy(uint8_t linkId) const;
+
+    /**
+     * \param linkId the ID of the given link
+     * \return the operating channel an aux PHY must switch to in order to operate
+     *         on the given link
+     */
+    const WifiPhyOperatingChannel& GetChannelForAuxPhy(uint8_t linkId) const;
+
+    /**
+     * \return the EML Operating Mode Notification to send
+     */
+    MgtEmlOmn GetEmlOmn();
+
     Time m_emlsrPaddingDelay;    //!< EMLSR Padding delay
     Time m_emlsrTransitionDelay; //!< EMLSR Transition delay
+    uint8_t m_mainPhyId; //!< ID of main PHY (position in the vector of PHYs held by WifiNetDevice)
+    uint16_t m_auxPhyMaxWidth; //!< max channel width (MHz) supported by aux PHYs
 
   private:
     /**
+     * Compute the operating channels that the main PHY and the aux PHY(s) must switch to in order
+     * to operate on each of the setup links. The operating channels may be different due to
+     * limited channel width capabilities of the aux PHY(s). This method shall be called upon
+     * completion of ML setup.
+     */
+    void ComputeOperatingChannels();
+
+    /**
      * Send an EML Operating Mode Notification frame.
      */
-    void SendEmlOperatingModeNotification();
+    void SendEmlOmn();
 
     /**
      * Notify the subclass of the reception of a management frame addressed to us.
@@ -159,10 +239,32 @@
     void ChangeEmlsrMode();
 
     /**
+     * Switch channel on the Main PHY so that it operates on the given link.
+     *
+     * \param linkId the ID of the link on which the main PHY has to operate
+     * \param noSwitchDelay whether switching delay should be zero
+     */
+    void SwitchMainPhy(uint8_t linkId, bool noSwitchDelay);
+
+    /**
+     * Adjust the operating channel of all the aux PHYs to meet the constraint on the maximum
+     * channel width supported by aux PHYs.
+     */
+    void ApplyMaxChannelWidthOnAuxPhys();
+
+    /**
      * Notify subclass that EMLSR mode changed.
      */
     virtual void NotifyEmlsrModeChanged() = 0;
 
+    /**
+     * Notify subclass that the main PHY is switching channel to operate on another link.
+     *
+     * \param currLinkId the ID of the link on which the main PHY is operating
+     * \param nextLinkId the ID of the link on which the main PHY will be operating
+     */
+    virtual void NotifyMainPhySwitch(uint8_t currLinkId, uint8_t nextLinkId) = 0;
+
     Ptr<StaWifiMac> m_staMac;                     //!< the MAC of the managed non-AP MLD
     std::optional<Time> m_emlsrTransitionTimeout; /**< Transition timeout advertised by APs with
                                                        EMLSR activated */
@@ -174,6 +276,11 @@
     Time m_lastAdvTransitionDelay;                     //!< last advertised transition delay
     EventId m_transitionTimeoutEvent; /**< Timer started after the successful transmission of an
                                            EML Operating Mode Notification frame */
+    bool m_resetCamState; //!< whether to reset the state of CAM when main PHY switches channel
+    std::map<uint8_t, WifiPhyOperatingChannel>
+        m_mainPhyChannels; //!< link ID-indexed map of operating channels for the main PHY
+    std::map<uint8_t, WifiPhyOperatingChannel>
+        m_auxPhyChannels; //!< link ID-indexed map of operating channels for the aux PHYs
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/eht/multi-link-element.cc ns-3.40/src/wifi/model/eht/multi-link-element.cc
--- ns-3.39/src/wifi/model/eht/multi-link-element.cc	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/eht/multi-link-element.cc	2023-09-27 13:30:37.902840000 -0700
@@ -269,6 +269,18 @@
     }
 }
 
+CommonInfoBasicMle&
+MultiLinkElement::GetCommonInfoBasic()
+{
+    return std::get<BASIC_VARIANT>(m_commonInfo);
+}
+
+const CommonInfoBasicMle&
+MultiLinkElement::GetCommonInfoBasic() const
+{
+    return std::get<BASIC_VARIANT>(m_commonInfo);
+}
+
 void
 MultiLinkElement::SetMldMacAddress(Mac48Address address)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/eht/multi-link-element.h ns-3.40/src/wifi/model/eht/multi-link-element.h
--- ns-3.39/src/wifi/model/eht/multi-link-element.h	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/eht/multi-link-element.h	2023-09-27 13:30:37.902840000 -0700
@@ -217,6 +217,12 @@
      */
     Variant GetVariant() const;
 
+    /// \return a reference to the Common Info field (the MLE variant must be Basic)
+    CommonInfoBasicMle& GetCommonInfoBasic();
+
+    /// \return a const reference to the Common Info field (the MLE variant must be Basic)
+    const CommonInfoBasicMle& GetCommonInfoBasic() const;
+
     /**
      * Set the MLD MAC Address subfield in the Common Info field. Make sure that
      * this is a Basic Multi-Link Element.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/eht/tid-to-link-mapping-element.cc ns-3.40/src/wifi/model/eht/tid-to-link-mapping-element.cc
--- ns-3.39/src/wifi/model/eht/tid-to-link-mapping-element.cc	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/eht/tid-to-link-mapping-element.cc	2023-09-27 13:30:37.902840000 -0700
@@ -17,20 +17,25 @@
  * Author: Sharan Naribole <sharan.naribole@gmail.com>
  */
 
-#include <ns3/assert.h>
-#include <ns3/tid-to-link-mapping-element.h>
+#include "tid-to-link-mapping-element.h"
+
+#include "ns3/assert.h"
+#include "ns3/simulator.h"
 
 namespace ns3
 {
 
+/// Bitmask with all bits from 63 to 26 set to 1, all the others set to 0
+static constexpr uint64_t BIT_63_TO_26_MASK = 0xfffffffffc000000;
+
 uint16_t
 TidToLinkMapping::Control::GetSubfieldSize() const
 {
-    // IEEE 802.11be D2.0 Figure 9-1002an
-    NS_ASSERT_MSG(defaultMapping != presenceBitmap.has_value(),
+    // IEEE 802.11be D3.1 Figure 9-1002ap
+    NS_ASSERT_MSG(!defaultMapping || !presenceBitmap.has_value(),
                   "Presence bitmap not expected if default mapping is set");
     auto size = WIFI_TID_TO_LINK_MAPPING_CONTROL_BASIC_SIZE_B;
-    if (defaultMapping)
+    if (!presenceBitmap.has_value())
     {
         return size;
     }
@@ -40,10 +45,12 @@
 void
 TidToLinkMapping::Control::Serialize(Buffer::Iterator& start) const
 {
-    uint8_t val = static_cast<uint8_t>(direction);
-    val |= ((defaultMapping ? 1 : 0) << 2);
+    auto val = static_cast<uint8_t>(direction) | ((defaultMapping ? 1 : 0) << 2) |
+               ((mappingSwitchTimePresent ? 1 : 0) << 3) |
+               ((expectedDurationPresent ? 1 : 0) << 4) | ((linkMappingSize == 1 ? 1 : 0) << 5);
+
     start.WriteU8(val);
-    NS_ASSERT_MSG(defaultMapping != presenceBitmap.has_value(),
+    NS_ASSERT_MSG(!defaultMapping || !presenceBitmap.has_value(),
                   "Presence bitmap not expected if default mapping is set");
     if (presenceBitmap.has_value())
     {
@@ -59,10 +66,14 @@
     auto val = i.ReadU8();
     count++;
 
-    direction = static_cast<TidLinkMapDir>(val & 0x03);
+    direction = static_cast<WifiDirection>(val & 0x03);
     defaultMapping = (((val >> 2) & 0x01) == 1);
+    mappingSwitchTimePresent = (((val >> 3) & 0x01) == 1);
+    expectedDurationPresent = (((val >> 4) & 0x01) == 1);
+    linkMappingSize = (((val >> 5) & 0x01) == 1 ? 1 : 2);
     if (defaultMapping)
     {
+        presenceBitmap.reset();
         return count;
     }
     presenceBitmap = i.ReadU8();
@@ -82,7 +93,60 @@
 }
 
 void
-TidToLinkMapping::SetLinkMappingOfTid(uint8_t tid, std::list<uint8_t> linkIds)
+TidToLinkMapping::SetMappingSwitchTime(Time mappingSwitchTime)
+{
+    // The 2 octet Mapping Switch Time field has units of TUs and is set to the time at which
+    // the new mapping is established using as a time-base the value of the TSF corresponding
+    // to the BSS identified by the BSSID of the frame containing the TID-To-Link Mapping
+    // element: i.e., bits 10 to 25 of the TSF. (Sec. 9.4.2.314 of 802.11be D3.1)
+    NS_ABORT_IF(mappingSwitchTime < Simulator::Now());
+    auto switchTimeUsec = static_cast<uint64_t>(mappingSwitchTime.GetMicroSeconds());
+    // set the Mapping Switch Time field to bits 10 to 25 of the given time
+    m_mappingSwitchTime = (switchTimeUsec & ~BIT_63_TO_26_MASK) >> 10;
+    m_control.mappingSwitchTimePresent = true;
+}
+
+std::optional<Time>
+TidToLinkMapping::GetMappingSwitchTime() const
+{
+    if (!m_control.mappingSwitchTimePresent)
+    {
+        return std::nullopt;
+    }
+
+    auto nowUsec = static_cast<uint64_t>(Simulator::Now().GetMicroSeconds());
+    uint64_t switchTimeUsec = (*m_mappingSwitchTime << 10) + (nowUsec & BIT_63_TO_26_MASK);
+    if (switchTimeUsec < nowUsec)
+    {
+        // The switch time derived from the value in the corresponding field may be less than the
+        // current time in case the bits 10 to 25 of TSF have been reset since the transmission
+        // of the frame carrying this field. In such a case we have to increase bits 63 to 26 by 1
+        switchTimeUsec += (1 << 26);
+    }
+    return MicroSeconds(switchTimeUsec);
+}
+
+void
+TidToLinkMapping::SetExpectedDuration(Time expectedDuration)
+{
+    auto durationTu = static_cast<uint64_t>(expectedDuration.GetMicroSeconds()) >> 10;
+    m_expectedDuration = (durationTu & 0x0000000000ffffff); // Expected Duration size is 3 bytes
+    m_control.expectedDurationPresent = true;
+}
+
+std::optional<Time>
+TidToLinkMapping::GetExpectedDuration() const
+{
+    if (!m_control.expectedDurationPresent)
+    {
+        return std::nullopt;
+    }
+
+    return MicroSeconds(*m_expectedDuration << 10);
+}
+
+void
+TidToLinkMapping::SetLinkMappingOfTid(uint8_t tid, std::set<uint8_t> linkIds)
 {
     NS_ABORT_MSG_IF(tid > 7, "Invalid tid: " << +tid);
     NS_ABORT_MSG_IF(m_control.defaultMapping,
@@ -94,35 +158,35 @@
     for (const auto& linkId : linkIds)
     {
         linkMapping |= (1 << linkId);
+        if (linkId > 7)
+        {
+            m_control.linkMappingSize = 2;
+        }
     }
 
     m_linkMapping[tid] = linkMapping;
-
-    if (!m_control.presenceBitmap.has_value())
-    {
-        m_control.presenceBitmap = 0;
-    }
-    *m_control.presenceBitmap |= (1 << tid);
+    m_control.presenceBitmap = m_control.presenceBitmap.value_or(0) | (1 << tid);
 }
 
-std::list<uint8_t>
+std::set<uint8_t>
 TidToLinkMapping::GetLinkMappingOfTid(uint8_t tid) const
 {
     auto it = m_linkMapping.find(tid);
 
-    if (it == m_linkMapping.end())
+    if (it == m_linkMapping.cend())
     {
         return {};
     }
 
-    std::list<uint8_t> linkIds;
+    std::set<uint8_t> linkIds;
     for (uint8_t linkId = 0; linkId < 15; linkId++)
     {
         if (((it->second >> linkId) & 0x0001) == 1)
         {
-            linkIds.push_back(linkId);
+            linkIds.insert(linkId);
         }
     }
+    NS_ABORT_MSG_IF(linkIds.empty(), "TID " << +tid << " cannot be mapped to an empty link set");
 
     return linkIds;
 }
@@ -130,26 +194,53 @@
 uint16_t
 TidToLinkMapping::GetInformationFieldSize() const
 {
-    // IEEE 802.11be D2.0 9.4.2.314 TID-To-Link Mapping element
+    // IEEE 802.11be D3.1 9.4.2.314 TID-To-Link Mapping element
     uint16_t ret = WIFI_IE_ELEMENT_ID_EXT_SIZE; // Element ID Extension
     ret += m_control.GetSubfieldSize();
-    NS_ASSERT_MSG(m_linkMapping.empty() == m_control.defaultMapping,
+    if (m_control.mappingSwitchTimePresent)
+    {
+        ret += 2; // Mapping Switch Time
+    }
+    if (m_control.expectedDurationPresent)
+    {
+        ret += 3; // Expected Duration
+    }
+
+    NS_ASSERT_MSG(!m_control.defaultMapping || m_linkMapping.empty(),
                   "Per-TID link mapping not expected if default mapping is set");
-    ret += WIFI_LINK_MAPPING_PER_TID_SIZE_B * (m_linkMapping.size());
+    ret += m_control.linkMappingSize * (m_linkMapping.size());
     return ret;
 }
 
 void
 TidToLinkMapping::SerializeInformationField(Buffer::Iterator start) const
 {
-    // IEEE 802.11be D2.0 9.4.2.314 TID-To-Link Mapping element
+    // IEEE 802.11be D3.1 9.4.2.314 TID-To-Link Mapping element
     m_control.Serialize(start);
-    NS_ASSERT_MSG(m_linkMapping.empty() == m_control.defaultMapping,
+    if (m_control.mappingSwitchTimePresent)
+    {
+        start.WriteHtolsbU16(*m_mappingSwitchTime);
+    }
+    if (m_control.expectedDurationPresent)
+    {
+        start.WriteU8((*m_expectedDuration >> 0) & 0xff);
+        start.WriteU8((*m_expectedDuration >> 8) & 0xff);
+        start.WriteU8((*m_expectedDuration >> 16) & 0xff);
+    }
+
+    NS_ASSERT_MSG(!m_control.defaultMapping || m_linkMapping.empty(),
                   "Per-TID link mapping not expected if default mapping is set");
 
     for (const auto& [tid, linkMapping] : m_linkMapping)
     {
-        start.WriteHtolsbU16(linkMapping);
+        if (m_control.linkMappingSize == 1)
+        {
+            start.WriteU8(linkMapping);
+        }
+        else
+        {
+            start.WriteHtolsbU16(linkMapping);
+        }
     }
 }
 
@@ -162,6 +253,23 @@
     NS_ASSERT_MSG(nCtrlOctets <= length, "Tid-to-Link Mapping deserialize error");
     i.Next(nCtrlOctets);
     count += nCtrlOctets;
+    if (m_control.mappingSwitchTimePresent)
+    {
+        m_mappingSwitchTime = i.ReadLsbtohU16();
+        count += 2;
+    }
+    if (m_control.expectedDurationPresent)
+    {
+        uint8_t byte0 = i.ReadU8();
+        uint8_t byte1 = i.ReadU8();
+        uint8_t byte2 = i.ReadU8();
+        m_expectedDuration = byte2;
+        m_expectedDuration.value() <<= 8;
+        m_expectedDuration.value() |= byte1;
+        m_expectedDuration.value() <<= 8;
+        m_expectedDuration.value() |= byte0;
+        count += 3;
+    }
     m_linkMapping.clear();
     if (m_control.presenceBitmap.has_value())
     {
@@ -172,8 +280,16 @@
         {
             if (((presenceBitmap >> tid) & 0x01) == 1)
             {
-                m_linkMapping[tid] = i.ReadLsbtohU16();
-                count += 2;
+                if (m_control.linkMappingSize == 1)
+                {
+                    m_linkMapping[tid] = i.ReadU8();
+                    count++;
+                }
+                else
+                {
+                    m_linkMapping[tid] = i.ReadLsbtohU16();
+                    count += 2;
+                }
             }
         }
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/eht/tid-to-link-mapping-element.h ns-3.40/src/wifi/model/eht/tid-to-link-mapping-element.h
--- ns-3.39/src/wifi/model/eht/tid-to-link-mapping-element.h	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/eht/tid-to-link-mapping-element.h	2023-09-27 13:30:37.902840000 -0700
@@ -20,33 +20,21 @@
 #ifndef TID_TO_LINK_MAPPING_H
 #define TID_TO_LINK_MAPPING_H
 
-#include <ns3/wifi-information-element.h>
+#include "ns3/nstime.h"
+#include "ns3/wifi-information-element.h"
+#include "ns3/wifi-utils.h"
 
-#include <list>
 #include <map>
 #include <optional>
-#include <vector>
+#include <set>
 
 namespace ns3
 {
 
-/**
- * TID-to-Link Mapping Control Direction
- * IEEE 802.11be D2.0 Figure 9-1002an
- */
-enum class TidLinkMapDir : uint8_t
-{
-    DOWNLINK = 0,
-    UPLINK = 1,
-    BOTH_DIRECTIONS = 2,
-};
-
 /// whether to enforce the default link mapping
 constexpr auto DEFAULT_WIFI_TID_LINK_MAPPING{true};
 /// default value for the Direction subfield of the TID-To-Link Control field
-constexpr auto DEFAULT_WIFI_TID_LINK_MAP_DIR{TidLinkMapDir::BOTH_DIRECTIONS};
-/// size in bytes of the Link Mapping Of TID n field (IEEE 802.11be D2.0 9.4.2.314)
-constexpr uint16_t WIFI_LINK_MAPPING_PER_TID_SIZE_B = 2;
+constexpr auto DEFAULT_WIFI_TID_LINK_MAP_DIR{WifiDirection::BOTH_DIRECTIONS};
 /// size in bytes of the TID-To-Link Control field with default link mapping
 constexpr uint16_t WIFI_TID_TO_LINK_MAPPING_CONTROL_BASIC_SIZE_B =
     1; // IEEE 802.11be D2.0 9.4.2.314
@@ -59,7 +47,7 @@
  *
  * This class serializes and deserializes
  * the TID-to-Link Mapping element
- * IEEE 802.11be D2.0 9.4.2.314
+ * IEEE 802.11be D3.1 9.4.2.314
  *
  */
 class TidToLinkMapping : public WifiInformationElement
@@ -67,13 +55,14 @@
   public:
     /**
      * TID-to-Link Mapping Control subfield
-     * IEEE 802.11be D2.0 Figure 9-1002an
+     * IEEE 802.11be D3.1 Figure 9-1002ap
      */
     struct Control
     {
-        TidLinkMapDir direction{DEFAULT_WIFI_TID_LINK_MAP_DIR}; ///< Direction
+        friend class TidToLinkMapping;
+
+        WifiDirection direction{DEFAULT_WIFI_TID_LINK_MAP_DIR}; ///< Direction
         bool defaultMapping{DEFAULT_WIFI_TID_LINK_MAPPING};     ///< Default link mapping
-        std::optional<uint8_t> presenceBitmap;                  ///< Link Mapping Presence Indicator
 
         /// \return Serialized size of TID-to-Link Mapping Control in octets
         uint16_t GetSubfieldSize() const;
@@ -91,31 +80,66 @@
          * \return the number of octets read
          */
         uint16_t Deserialize(Buffer::Iterator start);
+
+      private:
+        /**
+         * These members are private to prevent users to manipulate them directly (their values
+         * depend on the values of other fields)
+         */
+        bool mappingSwitchTimePresent{false}; ///< Mapping Switch Time Present
+        bool expectedDurationPresent{false};  ///< Expected Duration Present
+        uint8_t linkMappingSize{1}; ///< length of the Link Mapping Of TID n field in octets
+        std::optional<uint8_t> presenceBitmap; ///< Link Mapping Presence Indicator
     };
 
     WifiInformationElementId ElementId() const override;
     WifiInformationElementId ElementIdExt() const override;
 
     /**
+     * Set the Mapping Switch Time field.
+     *
+     * \param mappingSwitchTime the time when the new mapping is established (rounded to a
+     *                          multiple of a TU)
+     */
+    void SetMappingSwitchTime(Time mappingSwitchTime);
+
+    /// \return the value of the Mapping Switch Time field, if present.
+    std::optional<Time> GetMappingSwitchTime() const;
+
+    /**
+     * Set the Expected Duration field.
+     *
+     * \param expectedDuration the value for the Expected Duration field (rounded to a
+     *                         multiple of a TU)
+     */
+    void SetExpectedDuration(Time expectedDuration);
+
+    /// \return the value of the Expected Duration field, if present.
+    std::optional<Time> GetExpectedDuration() const;
+
+    /**
      * Set the Link Mapping field of the given TID such that the given TID is mapped
      * to the links associated with the given link IDs.
      *
      * \param tid the given TID
      * \param linkIds the IDs of the links which the given TID is mapped to
      */
-    void SetLinkMappingOfTid(uint8_t tid, std::list<uint8_t> linkIds);
+    void SetLinkMappingOfTid(uint8_t tid, std::set<uint8_t> linkIds);
     /**
      * Get the Link Mapping field of the given TID.
      *
      * \param tid the given TID
      * \return the IDs of the links which the given TID is mapped to
      */
-    std::list<uint8_t> GetLinkMappingOfTid(uint8_t tid) const;
+    std::set<uint8_t> GetLinkMappingOfTid(uint8_t tid) const;
 
     TidToLinkMapping::Control m_control;       ///< TID-to-link Mapping Control
     std::map<uint8_t, uint16_t> m_linkMapping; ///< TID-indexed Link Mapping
 
   private:
+    std::optional<uint16_t> m_mappingSwitchTime; ///< Mapping Switch Time
+    std::optional<uint32_t> m_expectedDuration;  ///< Expected Duration
+
     uint16_t GetInformationFieldSize() const override;
     void SerializeInformationField(Buffer::Iterator start) const override;
     uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/frame-exchange-manager.cc ns-3.40/src/wifi/model/frame-exchange-manager.cc
--- ns-3.39/src/wifi/model/frame-exchange-manager.cc	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/frame-exchange-manager.cc	2023-09-27 13:30:37.906839800 -0700
@@ -493,8 +493,7 @@
         // the timeout duration is "aSIFSTime + aSlotTime + aRxPHYStartDelay, starting
         // at the PHY-TXEND.confirm primitive" (section 10.3.2.9 or 10.22.2.2 of 802.11-2016).
         // aRxPHYStartDelay equals the time to transmit the PHY header.
-        WifiNormalAck* normalAcknowledgment =
-            static_cast<WifiNormalAck*>(m_txParams.m_acknowledgment.get());
+        auto normalAcknowledgment = static_cast<WifiNormalAck*>(m_txParams.m_acknowledgment.get());
 
         Time timeout =
             txDuration + m_phy->GetSifs() + m_phy->GetSlot() +
@@ -502,6 +501,7 @@
         NS_ASSERT(!m_txTimer.IsRunning());
         m_txTimer.Set(WifiTxTimer::WAIT_NORMAL_ACK,
                       timeout,
+                      {m_mpdu->GetHeader().GetAddr1()},
                       &FrameExchangeManager::NormalAckTimeout,
                       this,
                       m_mpdu,
@@ -525,6 +525,7 @@
 
     auto psdu = Create<WifiPsdu>(mpdu, false);
     FinalizeMacHeader(psdu);
+    m_allowedWidth = std::min(m_allowedWidth, txVector.GetChannelWidth());
     m_phy->Send(psdu, txVector);
 }
 
@@ -587,7 +588,7 @@
     }
     else if (protection->method == WifiProtection::RTS_CTS)
     {
-        WifiRtsCtsProtection* rtsCtsProtection = static_cast<WifiRtsCtsProtection*>(protection);
+        auto rtsCtsProtection = static_cast<WifiRtsCtsProtection*>(protection);
         rtsCtsProtection->protectionTime = m_phy->CalculateTxDuration(GetRtsSize(),
                                                                       rtsCtsProtection->rtsTxVector,
                                                                       m_phy->GetPhyBand()) +
@@ -598,8 +599,7 @@
     }
     else if (protection->method == WifiProtection::CTS_TO_SELF)
     {
-        WifiCtsToSelfProtection* ctsToSelfProtection =
-            static_cast<WifiCtsToSelfProtection*>(protection);
+        auto ctsToSelfProtection = static_cast<WifiCtsToSelfProtection*>(protection);
         ctsToSelfProtection->protectionTime =
             m_phy->CalculateTxDuration(GetCtsSize(),
                                        ctsToSelfProtection->ctsTxVector,
@@ -620,7 +620,7 @@
     }
     else if (acknowledgment->method == WifiAcknowledgment::NORMAL_ACK)
     {
-        WifiNormalAck* normalAcknowledgment = static_cast<WifiNormalAck*>(acknowledgment);
+        auto normalAcknowledgment = static_cast<WifiNormalAck*>(acknowledgment);
         normalAcknowledgment->acknowledgmentTime =
             m_phy->GetSifs() + m_phy->CalculateTxDuration(GetAckSize(),
                                                           normalAcknowledgment->ackTxVector,
@@ -706,8 +706,7 @@
     rts.SetAddr2(m_self);
 
     NS_ASSERT(txParams.m_protection && txParams.m_protection->method == WifiProtection::RTS_CTS);
-    WifiRtsCtsProtection* rtsCtsProtection =
-        static_cast<WifiRtsCtsProtection*>(txParams.m_protection.get());
+    auto rtsCtsProtection = static_cast<WifiRtsCtsProtection*>(txParams.m_protection.get());
 
     NS_ASSERT(txParams.m_txDuration != Time::Min());
     rts.SetDuration(GetRtsDurationId(rtsCtsProtection->rtsTxVector,
@@ -726,6 +725,7 @@
     NS_ASSERT(!m_txTimer.IsRunning());
     m_txTimer.Set(WifiTxTimer::WAIT_CTS,
                   timeout,
+                  {receiver},
                   &FrameExchangeManager::CtsTimeout,
                   this,
                   mpdu,
@@ -807,8 +807,7 @@
 
     NS_ASSERT(txParams.m_protection &&
               txParams.m_protection->method == WifiProtection::CTS_TO_SELF);
-    WifiCtsToSelfProtection* ctsToSelfProtection =
-        static_cast<WifiCtsToSelfProtection*>(txParams.m_protection.get());
+    auto ctsToSelfProtection = static_cast<WifiCtsToSelfProtection*>(txParams.m_protection.get());
 
     NS_ASSERT(txParams.m_txDuration != Time::Min());
     cts.SetDuration(GetCtsToSelfDurationId(ctsToSelfProtection->ctsTxVector,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/frame-exchange-manager.h ns-3.40/src/wifi/model/frame-exchange-manager.h
--- ns-3.39/src/wifi/model/frame-exchange-manager.h	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/frame-exchange-manager.h	2023-09-27 13:30:37.906839800 -0700
@@ -30,12 +30,12 @@
 #include "wifi-tx-timer.h"
 #include "wifi-tx-vector.h"
 
-#include "ns3/object.h"
 // Needed to compile wave bindings
 #include "channel-access-manager.h"
+#include "wifi-ack-manager.h"
+#include "wifi-protection-manager.h"
 
-#include "ns3/wifi-ack-manager.h"
-#include "ns3/wifi-protection-manager.h"
+#include "ns3/object.h"
 
 namespace ns3
 {
@@ -635,7 +635,6 @@
      */
     virtual void Reset();
 
-  private:
     /**
      * \param txVector the TXVECTOR decoded from PHY header.
      * \param psduDuration the duration of the PSDU that is about to be received.
@@ -646,8 +645,9 @@
      * If the reception is correct for at least one MPDU of the PSDU
      * the Receive method will be called after \p psduDuration.
      */
-    void RxStartIndication(WifiTxVector txVector, Time psduDuration);
+    virtual void RxStartIndication(WifiTxVector txVector, Time psduDuration);
 
+  private:
     /**
      * Send the current MPDU, which can be acknowledged by a Normal Ack.
      */
